Index: trunk/LMDZ.COMMON/libf/evolution/soil_pem.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/evolution/soil_pem.F90	(revision 2794)
+++ trunk/LMDZ.COMMON/libf/evolution/soil_pem.F90	(revision 2794)
@@ -0,0 +1,162 @@
+      subroutine soil_pem(ngrid,nsoil,firstcall, &
+               therm_i,                          &
+               timestep,tsurf,tsoil,alph_PEM,beta_PEM)
+
+
+      use comsoil_h_PEM, only: layer_PEM, mlayer_PEM,  &
+                          mthermdiff_PEM, thermdiff_PEM, coefq_PEM, &
+                          coefd_PEM, mu_PEM,fluxgeo
+      use comsoil_h,only: volcapa
+      implicit none
+
+!-----------------------------------------------------------------------
+!  Author: LL
+!  Purpose: Compute soil temperature using an implict 1st order scheme
+!  
+!  Note: depths of layers and mid-layers, soil thermal inertia and 
+!        heat capacity are commons in comsoil_PEM.h
+!        A convergence loop is added until equilibrium
+!-----------------------------------------------------------------------
+
+#include "dimensions.h"
+!#include "dimphys.h"
+
+!#include"comsoil.h"
+
+
+!-----------------------------------------------------------------------
+!  arguments
+!  ---------
+!  inputs:
+      integer,intent(in) :: ngrid	! number of (horizontal) grid-points 
+      integer,intent(in) :: nsoil	! number of soil layers  
+      logical,intent(in) :: firstcall ! identifier for initialization call 
+      real,intent(in) :: therm_i(ngrid,nsoil) ! thermal inertia
+      real,intent(in) :: timestep	    ! time step
+      real,intent(in) :: tsurf(ngrid)   ! surface temperature
+ 
+! outputs:
+      real,intent(inout) :: tsoil(ngrid,nsoil) ! soil (mid-layer) temperature
+      real,intent(inout) :: alph_PEM(ngrid,nsoil-1)
+      real,intent(inout) :: beta_PEM(ngrid,nsoil-1)
+
+
+
+
+      
+! local variables:
+      integer ig,ik
+
+
+     
+
+! 0. Initialisations and preprocessing step
+ if (firstcall) then
+    
+! 0.1 Build mthermdiff_PEM(:), the mid-layer thermal diffusivities
+      do ig=1,ngrid
+        do ik=0,nsoil-1
+	  mthermdiff_PEM(ig,ik)=therm_i(ig,ik+1)*therm_i(ig,ik+1)/volcapa
+    
+	enddo
+      enddo
+
+
+! 0.2 Build thermdiff(:), the "interlayer" thermal diffusivities
+      do ig=1,ngrid
+        do ik=1,nsoil-1
+      thermdiff_PEM(ig,ik)=((layer_PEM(ik)-mlayer_PEM(ik-1))*mthermdiff_PEM(ig,ik) &
+                     +(mlayer_PEM(ik)-layer_PEM(ik))*mthermdiff_PEM(ig,ik-1))  &
+                         /(mlayer_PEM(ik)-mlayer_PEM(ik-1))
+
+	enddo
+      enddo
+
+! 0.3 Build coefficients mu_PEM, q_{k+1/2}, d_k, alph_PEMa_k and capcal
+      ! mu_PEM
+      mu_PEM=mlayer_PEM(0)/(mlayer_PEM(1)-mlayer_PEM(0))
+
+      ! q_{1/2}
+      coefq_PEM(0)=volcapa*layer_PEM(1)/timestep
+	! q_{k+1/2}
+        do ik=1,nsoil-1
+          coefq_PEM(ik)=volcapa*(layer_PEM(ik+1)-layer_PEM(ik)) 		 &
+                      /timestep
+	enddo
+
+      do ig=1,ngrid
+	! d_k
+	do ik=1,nsoil-1
+	  coefd_PEM(ig,ik)=thermdiff_PEM(ig,ik)/(mlayer_PEM(ik)-mlayer_PEM(ik-1))
+	enddo
+	
+	! alph_PEM_{N-1}
+	alph_PEM(ig,nsoil-1)=coefd_PEM(ig,nsoil-1)/ 			 &
+                       (coefq_PEM(nsoil-1)+coefd_PEM(ig,nsoil-1))
+        ! alph_PEM_k
+        do ik=nsoil-2,1,-1
+	  alph_PEM(ig,ik)=coefd_PEM(ig,ik)/(coefq_PEM(ik)+coefd_PEM(ig,ik+1)*    &
+                                   (1.-alph_PEM(ig,ik+1))+coefd_PEM(ig,ik))
+	enddo
+
+
+      enddo ! of do ig=1,ngrid
+
+      
+  
+endif ! of if (firstcall)
+
+
+
+      IF (.not.firstcall) THEN
+!  2. Compute soil temperatures
+! First layer:
+
+
+
+
+      do ig=1,ngrid
+        tsoil(ig,1)=(tsurf(ig)+mu_PEM*beta_PEM(ig,1)* &  
+                                  thermdiff_PEM(ig,1)/mthermdiff_PEM(ig,0))/ &
+                   (1.+mu_PEM*(1.0-alph_PEM(ig,1))*&
+                    thermdiff_PEM(ig,1)/mthermdiff_PEM(ig,0))
+     
+
+  
+
+
+! Other layers:
+      do ik=1,nsoil-1
+
+          tsoil(ig,ik+1)=alph_PEM(ig,ik)*tsoil(ig,ik)+beta_PEM(ig,ik)
+
+ 
+       enddo
+      
+     enddo
+          ENDIF
+
+
+
+
+!  2. Compute beta_PEM coefficients (preprocessing for next time step)
+! Bottom layer, beta_PEM_{N-1}
+      do ig=1,ngrid
+        beta_PEM(ig,nsoil-1)=coefq_PEM(nsoil-1)*tsoil(ig,nsoil)		 &
+                        /(coefq_PEM(nsoil-1)+coefd_PEM(ig,nsoil-1)) & 
+                 +  fluxgeo/(coefq_PEM(nsoil-1)+coefd_PEM(ig,nsoil-1))
+      enddo
+! Other layers
+      do ik=nsoil-2,1,-1
+        do ig=1,ngrid
+	  beta_PEM(ig,ik)=(coefq_PEM(ik)*tsoil(ig,ik+1)+		 &
+                      coefd_PEM(ig,ik+1)*beta_PEM(ig,ik+1))/		 &
+                      (coefq_PEM(ik)+coefd_PEM(ig,ik+1)*(1.0-alph_PEM(ig,ik+1)) &
+                       +coefd_PEM(ig,ik))
+	enddo
+      enddo
+
+
+
+      end
+
Index: trunk/LMDZ.COMMON/libf/evolution/soil_settings_PEM.F
===================================================================
--- trunk/LMDZ.COMMON/libf/evolution/soil_settings_PEM.F	(revision 2794)
+++ trunk/LMDZ.COMMON/libf/evolution/soil_settings_PEM.F	(revision 2794)
@@ -0,0 +1,105 @@
+      subroutine soil_settings_PEM(ngrid,nslope,nsoil_PEM,nsoil_GCM,
+     &   TI_GCM,TI_PEM)
+
+
+!      use netcdf
+      use comsoil_h_PEM, only: layer_PEM, mlayer_PEM
+      use comsoil_h, only: inertiedat,layer,mlayer, volcapa
+      use iostart, only: inquire_field_ndims, get_var, get_field,
+     &                   inquire_field, inquire_dimension_length
+
+      implicit none
+
+!======================================================================
+!  Author: Ehouarn Millour (07/2006)
+!
+!  Purpose: Read and/or initialise soil depths and properties
+!
+! Modifications: Aug.2010 EM : use NetCDF90 to load variables (enables using
+!                      r4 or r8 restarts independently of having compiled
+!                      the GCM in r4 or r8)
+!                June 2013 TN : Possibility to read files with a time axis
+!
+!
+!  This subroutine reads from a NetCDF file (opened by the caller)
+!  of "startfi.nc" format.
+!  The various actions and variable read/initialized are:
+!  1. Check out the number of soil layers (in datafile); if it isn't equal
+!     to nsoil, then some interpolation will be required
+!     Also check if data in file "startfi.nc" is in older format (ie:
+!     thermal inertia was depth-independent; and there was no "depth"
+!     coordinate.
+!     Read/build layer (and midlayer) depths
+!  2. Read volumetric specific heat (or initialise it to default value)
+!  3. Read Thermal inertia
+!  4. Read soil temperatures
+!  5. Interpolate thermal inertia and temperature on the new grid, if
+!     necessary
+!======================================================================
+
+!======================================================================
+!  arguments
+!  ---------
+!  inputs:
+      integer,intent(in) :: ngrid	! # of horizontal grid points
+      integer,intent(in) :: nslope	! # of subslope wihtin the mesh
+      integer,intent(in) :: nsoil_PEM	! # of soil layers in the PEM
+      integer,intent(in) :: nsoil_GCM	! # of soil layers in the GCM
+      real,intent(in) :: TI_GCM(ngrid,nsoil_GCM,nslope)	! # of soil layers in the GCM
+      real,intent(inout) :: TI_PEM(ngrid,nsoil_PEM,nslope)	! # of soil layers in the PEM
+
+!======================================================================
+! local variables:
+      integer ig,iloop,islope	! loop counters
+      logical found
+
+      real alpha,lay1 ! coefficients for building layers
+      real xmin,xmax ! to display min and max of a field
+
+
+      
+!======================================================================
+
+! 1. Depth coordinate
+! -------------------
+
+! 1.4 Build mlayer(), if necessary
+!      if (interpol) then
+      ! default mlayer distribution, following a power law:
+      !  mlayer(k)=lay1*alpha**(k-1/2)
+        lay1=2.e-4
+	alpha=2
+        do iloop=0,nsoil_PEM-1
+	  mlayer_PEM(iloop)=lay1*(alpha**(iloop-0.5))
+	enddo
+!      endif
+
+! 1.5 Build layer(); following the same law as mlayer()
+      ! Assuming layer distribution follows mid-layer law:
+      ! layer(k)=lay1*alpha**(k-1)
+      lay1=sqrt(mlayer_PEM(0)*mlayer_PEM(1))
+      alpha=mlayer_PEM(1)/mlayer_PEM(0)
+      do iloop=1,nsoil_PEM
+        layer_PEM(iloop)=lay1*(alpha**(iloop-1))
+      enddo
+
+
+
+
+! 2. Thermal inertia (note: it is declared in comsoil_h)
+! ------------------
+
+
+      do ig = 1,ngrid
+        do islope = 1,nslope
+          do iloop = 1,nsoil_GCM
+            TI_PEM(ig,iloop,islope) = TI_GCM(ig,iloop,islope)
+          enddo
+          if(nsoil_PEM.gt.nsoil_GCM) then
+           do iloop = nsoil_GCM+1,nsoil_PEM
+             TI_PEM(ig,iloop,islope) = TI_GCM(ig,nsoil_GCM,islope)
+           enddo
+          endif
+        enddo
+      enddo
+      end subroutine soil_settings_PEM
Index: trunk/LMDZ.COMMON/libf/evolution/update_soil.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/evolution/update_soil.F90	(revision 2794)
+++ trunk/LMDZ.COMMON/libf/evolution/update_soil.F90	(revision 2794)
@@ -0,0 +1,183 @@
+   SUBROUTINE update_soil(ngrid,nslope,nsoil_PEM,tend_h2oglaciers,tend_co2glaciers,co2ice,waterice,ps_new,&
+                          cellarea,ice_depth,TI_PEM)
+
+
+ USE comsoil_h, only:  inertiedat, volcapa
+ USE comsoil_h_PEM, only: layer_PEM,n_1km,inertiedat_PEM
+ USE vertical_layers_mod, ONLY: ap,bp
+ implicit none
+! Input: 
+ INTEGER,INTENT(IN) ::  ngrid, nslope, nsoil_PEM
+ REAL,INTENT(IN) :: tend_h2oglaciers(ngrid,nslope),tend_co2glaciers(ngrid,nslope)
+ REAL,INTENT(IN) :: ps_new(ngrid)
+ REAL,INTENT(IN) :: cellarea(ngrid)
+ REAL,INTENT(IN) :: co2ice(ngrid,nslope)
+ REAL,INTENT(IN) :: waterice(ngrid,nslope)
+ REAL,INTENT(in) :: ice_depth(ngrid,nslope)
+ 
+
+! Outputs:
+
+ REAL,INTENT(INOUT) :: TI_PEM(ngrid,nsoil_PEM,nslope)
+  
+! Constants:
+
+ REAL ::  alpha = 0.2
+ REAL ::  beta = 1.08e7
+ REAL ::  To = 273.15
+ REAL ::  R =  8.314
+ REAL ::  L =  51058.
+ REAL ::  inertie_thresold = 800. ! look for ice
+ REAL ::  inertie_co2glaciers = 2120 ! Mellon et al. 2000
+ REAL ::  inertie_averaged = 250 ! Mellon et al. 2000
+ REAL ::  ice_inertia = 2120  ! Inertia of ice
+ REAL ::  surfaceice_inertia = 800  ! Inertia of ice
+ REAL ::  P610 = 610.0
+ REAL ::  m_h2o = 18.01528E-3
+ REAL ::  m_co2 = 44.01E-3  ! CO2 molecular mass (kg/mol)   
+ REAL ::  m_noco2 = 33.37E-3  ! Non condensible mol mass (kg/mol)   
+ REAL ::  A,B,mmean             
+
+! Local variables:
+
+ INTEGER :: ig,islope,iloop,iref,k
+ REAL :: regolith_inertia(ngrid,nslope) ! TI of the regolith 
+ REAL :: d(ngrid,nsoil_PEM,nslope)
+ REAL :: p_avg_new
+ REAL :: Total_surface
+ INTEGER :: ispermanent_co2glaciers(ngrid,nslope)
+ INTEGER :: ispermanent_h2oglaciers(ngrid,nslope)
+
+
+! 0. Initialisation
+
+
+
+
+  Total_surface = sum(cellarea)
+  p_avg_new = 0.
+  do ig = 1,ngrid
+    p_avg_new = p_avg_new + ps_new(ig)*cellarea(ig)/Total_surface
+  enddo
+
+
+
+  do ig = 1,ngrid
+    do islope = 1,nslope
+     if((abs(tend_h2oglaciers(ig,islope)).lt.1e-5).and.(abs(waterice(ig,islope)).gt.0)) then
+        ispermanent_h2oglaciers(ig,islope) = 1
+     else
+        ispermanent_h2oglaciers(ig,islope) = 0
+     endif 
+
+     if((abs(tend_co2glaciers(ig,islope)).lt.1e-5).and.(abs(co2ice(ig,islope)).gt.0)) then
+        ispermanent_co2glaciers(ig,islope) = 1
+     else
+        ispermanent_co2glaciers(ig,islope) = 0
+     endif
+    enddo
+
+  enddo
+
+
+ ispermanent_co2glaciers(:,:) = 0
+ ispermanent_h2oglaciers(:,:) = 0
+
+
+!  1.Ice TI feedback
+
+!  do ig=1,ngrid
+!    do islope=1,nslope
+!      if ((ispermanent_co2glaciers(ig,islope).eq.1).or.(ispermanent_h2oglaciers(ig,islope).eq.1)) then
+!       do iloop = 1,n_1km
+!         TI_PEM(ig,iloop,islope) = surfaceice_inertia
+!       enddo
+!      endif
+!    enddo
+!   enddo
+    do islope = 1,nslope
+     call soil_TIfeedback_PEM(ngrid,nsoil_PEM,waterice(:,islope),   TI_PEM(:,:,islope))
+    enddo
+
+! 2. Modification of the regolith thermal inertia.
+
+
+
+  do ig=1,ngrid
+    do islope=1,nslope
+     do iloop =1,n_1km
+       d(ig,iloop,islope) = ((inertiedat_PEM(ig,iloop)*inertiedat_PEM(ig,iloop))/(volcapa*alpha*P610**0.6))**(-1/(0.11*log10(P610/beta)))
+   if(TI_PEM(ig,iloop,islope).lt.inertie_thresold) then !           we are modifying the regolith properties, not ice
+          TI_PEM(ig,iloop,islope) = sqrt(volcapa*alpha*(p_avg_new**0.6)* d(ig,iloop,islope)**(-0.11*log10(p_avg_new/beta)))
+
+   endif 
+     enddo
+   enddo
+enddo
+
+
+
+
+
+
+!  3. Build new TI for the PEM
+! a) For the regolith
+  do ig=1,ngrid
+    do islope=1,nslope
+
+  if (ice_depth(ig,islope).gt. -1.e-10) then
+! 3.0 FIrst if permanent ice
+   if (ice_depth(ig,islope).lt. 1e-10) then
+      do iloop = 1,nsoil_PEM
+       TI_PEM(ig,iloop,islope)=max(ice_inertia,inertiedat_PEM(ig,iloop))
+      enddo
+     else 
+      ! 4.1 find the index of the mixed layer
+      iref=0 ! initialize iref
+      do k=1,nsoil_PEM ! loop on layers
+        if (ice_depth(ig,islope).ge.layer_PEM(k)) then
+          iref=k ! pure regolith layer up to here
+        else
+         ! correct iref was obtained in previous cycle
+         exit
+        endif
+       
+      enddo
+
+
+
+      ! 4.2 Build the new ti
+      do iloop=1,iref
+         TI_PEM(ig,iloop,islope) =TI_PEM(ig,iloop,islope)
+      enddo
+      if (iref.lt.nsoil_PEM) then
+        if (iref.ne.0) then
+          ! mixed layer
+           TI_PEM(ig,iref+1,islope)=sqrt((layer_PEM(iref+1)-layer_PEM(iref))/ &
+            (((ice_depth(ig,islope)-layer_PEM(iref))/(TI_PEM(ig,iref,islope)**2))+ &
+                      ((layer_PEM(iref+1)-ice_depth(ig,islope))/(ice_inertia**2))))
+        else ! first layer is already a mixed layer
+          ! (ie: take layer(iref=0)=0)
+          TI_PEM(ig,1,islope)=sqrt((layer_PEM(1))/ &
+                          (((ice_depth(ig,islope))/(TI_PEM(ig,1,islope)**2))+ &
+                           ((layer_PEM(1)-ice_depth(ig,islope))/(ice_inertia**2))))
+        endif ! of if (iref.ne.0)        
+        ! lower layers of pure ice
+        do iloop=iref+2,nsoil_PEM
+          TI_PEM(ig,iloop,islope)=ice_inertia
+        enddo
+      endif ! of if (iref.lt.(nsoilmx))
+      endif ! permanent glaciers
+      endif ! depth > 0
+     enddo !islope
+    enddo !ig
+
+
+
+
+
+
+
+!=======================================================================
+      RETURN
+      END
